# coding: utf-8

"""
    Immich

    Immich API

    The version of the OpenAPI document: 1.134.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List
from immich_python_sdk.models.colorspace import Colorspace
from immich_python_sdk.models.system_config_generated_fullsize_image_dto import SystemConfigGeneratedFullsizeImageDto
from immich_python_sdk.models.system_config_generated_image_dto import SystemConfigGeneratedImageDto
from typing import Optional, Set
from typing_extensions import Self

class SystemConfigImageDto(BaseModel):
    """
    SystemConfigImageDto
    """ # noqa: E501
    colorspace: Colorspace
    extract_embedded: StrictBool = Field(alias="extractEmbedded")
    fullsize: SystemConfigGeneratedFullsizeImageDto
    preview: SystemConfigGeneratedImageDto
    thumbnail: SystemConfigGeneratedImageDto
    __properties: ClassVar[List[str]] = ["colorspace", "extractEmbedded", "fullsize", "preview", "thumbnail"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SystemConfigImageDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of fullsize
        if self.fullsize:
            _dict['fullsize'] = self.fullsize.to_dict()
        # override the default output from pydantic by calling `to_dict()` of preview
        if self.preview:
            _dict['preview'] = self.preview.to_dict()
        # override the default output from pydantic by calling `to_dict()` of thumbnail
        if self.thumbnail:
            _dict['thumbnail'] = self.thumbnail.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SystemConfigImageDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "colorspace": obj.get("colorspace"),
            "extractEmbedded": obj.get("extractEmbedded"),
            "fullsize": SystemConfigGeneratedFullsizeImageDto.from_dict(obj["fullsize"]) if obj.get("fullsize") is not None else None,
            "preview": SystemConfigGeneratedImageDto.from_dict(obj["preview"]) if obj.get("preview") is not None else None,
            "thumbnail": SystemConfigGeneratedImageDto.from_dict(obj["thumbnail"]) if obj.get("thumbnail") is not None else None
        })
        return _obj


