# coding: utf-8

"""
    Immich

    Immich API

    The version of the OpenAPI document: 1.134.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from immich_python_sdk.models.user_avatar_color import UserAvatarColor
from typing import Optional, Set
from typing_extensions import Self

class UserAdminCreateDto(BaseModel):
    """
    UserAdminCreateDto
    """ # noqa: E501
    avatar_color: Optional[UserAvatarColor] = Field(default=None, alias="avatarColor")
    email: StrictStr
    name: StrictStr
    notify: Optional[StrictBool] = None
    password: StrictStr
    quota_size_in_bytes: Optional[Annotated[int, Field(strict=True, ge=0)]] = Field(default=None, alias="quotaSizeInBytes")
    should_change_password: Optional[StrictBool] = Field(default=None, alias="shouldChangePassword")
    storage_label: Optional[StrictStr] = Field(default=None, alias="storageLabel")
    __properties: ClassVar[List[str]] = ["avatarColor", "email", "name", "notify", "password", "quotaSizeInBytes", "shouldChangePassword", "storageLabel"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserAdminCreateDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if avatar_color (nullable) is None
        # and model_fields_set contains the field
        if self.avatar_color is None and "avatar_color" in self.model_fields_set:
            _dict['avatarColor'] = None

        # set to None if quota_size_in_bytes (nullable) is None
        # and model_fields_set contains the field
        if self.quota_size_in_bytes is None and "quota_size_in_bytes" in self.model_fields_set:
            _dict['quotaSizeInBytes'] = None

        # set to None if storage_label (nullable) is None
        # and model_fields_set contains the field
        if self.storage_label is None and "storage_label" in self.model_fields_set:
            _dict['storageLabel'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserAdminCreateDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "avatarColor": obj.get("avatarColor"),
            "email": obj.get("email"),
            "name": obj.get("name"),
            "notify": obj.get("notify"),
            "password": obj.get("password"),
            "quotaSizeInBytes": obj.get("quotaSizeInBytes"),
            "shouldChangePassword": obj.get("shouldChangePassword"),
            "storageLabel": obj.get("storageLabel")
        })
        return _obj


